/* ______      ____      __
  / ____/___  / __ \    / /_  ______ ___  ____  ___  _____ _________  ____ ___
 / /   / __ \/ / / /_  / / / / / __ `__ \/ __ \/ _ \/ ___// ___/ __ \/ __ `__ \
/ /___/ /_/ / /_/ / /_/ / /_/ / / / / / / /_/ /  __/ /  _/ /__/ /_/ / / / / / /
\____/\____/_____/\____/\__,_/_/ /_/ /_/ .___/\___/_/  (_)___/\____/_/ /_/ /_/
                                      /_/
   --------------------------------------------------
   - Thanks for taking an interest in OUR mod.      -
   - Feel free to borrow our code and claim it as   -
   - your own. It hasn't stopped you in the past.   -                                         -
   -               * CoDJumper Team *               -
   ------------------------------------------------*/

// Admin Menu
//	- Rcon Login
//	- Change Map
//	- Restart Map
//	- Kick/Ban Player
//	- Enable/Disable Voting
//	- Promote/Demote
//	- Punishments
//	- Small/Big Say
//	- Time limit
// Send PM (P2P)

#include maps\mp\gametypes\_cj_utility;
#include maps\mp\gametypes\_hud_util;
#include common_scripts\utility;

init()
{
	level._author = "Drofder@CoDJumper.com";			// Author
	level._version = "3.11";											// Version
	level._date = "29.06.10";											// Date
	level._translators_german = "Lev!athan & TheDude";		// German
	level._translators_french = "BlueDamselfly";	// French
	level._translators_polish = "Tr4b4nt";				// Polish
	level._translators_dutch = "[SoE]_Zaitsev";		// Dutch
	level._specialthanks = "T3chn0r, Soviet@CoDJumper.com";							// www.openwarfaremod.com

	maps\mp\gametypes\_cj_setup::precacheStuff(); 		// Precache
	maps\mp\gametypes\_cj_setup::setupDvars(); 				// Dvars
	thread maps\mp\gametypes\_cj_setup::setupInfo();	// Mod Info



	thread RemoveTurrets();								// Remove Turrets
	thread maps\mp\gametypes\_cj_punish::punishments();	// Punish
	adminSetup();													// Pro/Demote
	thread onPlayerConnect();							// OnPlayerConnect

	thread rotateMessage();								// Rotating Messages
	thread _svr_msg();										// Send Server Message
	thread _player_msg();									// Send Private Message
	thread voteCancelled();								// Waits for votes to be cancelled
	thread voteForced();									// Waits for votes to be forced
	thread mapList();											// Creates an array of maps
	thread getPlayerStatus();							// Creates an array of promoted players at map end
	thread playerStatusArray();						// Creates an array of promoted players at map start
	//thread bots();
}

onPlayerConnect()
{
	for(;;)
	{
		level waittill("connected", player);
		player.cj = [];
		player.cj["save"] = [];
		player.cj["vote"] = [];
		player.cj["hud"] = [];
		player.cj["third"] = [];
		player.cj["third"]["ang"] = 0;
		player.cj["third"]["range"] = 120;
		player.cj["status"] = 0;
		player.cj["vote"]["novoting"] = true;
		player.cj["vote"]["voted"] = false;
		player.cj["time"] = [];
		player.cj["time"]["played"] = 0;
		player.cj["time"]["count"] = 0;
		player.cj["admin"] = [];
		player.cj["admin"]["frozen"] = 0;
		player.triggerWait = 0;
		player setClientDvar("player_summary_time", player.cj["time"]["played"]);
		player setClientDvar("aim_automelee_range", 0);
		player setClientDvar("gdecalstate", "^2");
		player setClientDvar("gfullbrightstate", "^1");
		player setClientDvar("gfxstate", "^2");
		player setClientDvar("gdrawstate", "^1off");
		player setClientDvar("gfogstate", "^2");
		player setClientDvar("gthirdstate", "^1");

		player thread checkPlayerStatus();
		player thread maps\mp\gametypes\_cj_setup::setupLanguage();

		player thread setupAdvert();

		if((getDvar("cj_adminguids") != "-1") && (getDvarInt("cj_autoadmin") == 1))
			player thread checkAdmin();

		player thread onPlayerSpec();
		player thread onPlayerSpawned();
		player thread playerList();
		player thread mapBrowse();
	}
}

onPlayerSpec()
{
	for(;;)
	{
		self waittill("joined_spectators");
		self thread changeAdvert();
		self thread maps\mp\gametypes\_cj_commands::onCustomMenuResponse();
	}
}

onPlayerSpawned()
{
	for(;;)
	{
		self waittill("spawned_player");
		self notify("endcommands");

		self thread _MeleeKey();						// Melee Key Watch
		self thread _UseKey();							// Use Key Watch
		self thread checkGrenades();				// Grenade Watch

		self thread removeAmmo();						// Remove ammo & loadout
		self thread removePerks();					// Remove Perks
		self thread checkSuicide();					// Check for Suicide
		self thread maps\mp\gametypes\_cj_commands::onCustomMenuResponse();	// Get Quick Commands Menu
		self thread doWelcomeMessages();		// Welcome Player

		self thread timeCount();						// Count for participation

		if(self.cj["status"] == 1)
			self setRank(level.maxrank+1, 0);
		else if(self.cj["status"] == 2)
			self setRank(level.maxrank+2, 0);
		else if(self.cj["status"] == 3)
			self setRank(level.maxrank+3, 0);
		else
		{
			rankId = self maps\mp\gametypes\_rank::getRankForXp( self maps\mp\gametypes\_rank::getRankXP() );
			if(rankId > level.maxrank)
				self setRank(level.maxrank, 0);
			else
				self setRank(rankId);
		}

		self thread changeAdvert();				// Modify Adverts
	}
}

// Load, Save & Suicide //
_MeleeKey()
{
  	
level.whatisthisfuckingmap = getDvar("mapname");
  
    self endon("disconnect");
	self endon("killed_player");
	self endon("joined_spectators");

	for(;;)
	{
	if(level.whatisthisfuckingmap != "mp_4gf_jump")
  {	
    if(self meleeButtonPressed())
		{
			catch_next = false;
			count = 0;

			for(i=0; i<0.5; i+=0.05)
			{
				if(catch_next && self meleeButtonPressed() && self isOnground())
				{
					self thread savePos();
                    wait 1;
					break;
				}
				else if(catch_next && self attackButtonPressed() && self isOnGround())
				{
					while(self attackButtonPressed() && count < 1)
					{
						count+=0.1;
						wait 0.1;
					}
					if(count >= 1 && self isOnGround())
						self thread savePos3();
					else if(count < 1 && self isOnGround())
						self thread savePos2();

					wait 1;
					break;
				}
				else if(!(self meleeButtonPressed()) && !(self attackButtonPressed()))
					catch_next = true;

				wait 0.05;
			}
			}
		}
else
{    if(self meleeButtonPressed())
		{
			catch_next = false;
			count = 0;

			for(i=0; i<0.5; i+=0.05)
			{
				if(catch_next && self meleeButtonPressed() && self isOnground())
				{
					self thread maps\mp\_save::savePos();
                    wait 1;
					break;
				}
				else if(catch_next && self attackButtonPressed() && self isOnGround())
				{
					while(self attackButtonPressed() && count < 1)
					{
						count+=0.1;
						wait 0.1;
					}
					if(count >= 1 && self isOnGround())
						self thread maps\mp\_save::savePos3();
					else if(count < 1 && self isOnGround())
						self thread maps\mp\_save::savePos2();

					wait 1;
					break;
				}
				else if(!(self meleeButtonPressed()) && !(self attackButtonPressed()))
					catch_next = true;

				wait 0.05;
			}
			}
        }
		wait 0.05;
	}
}

_UseKey()
{
	self endon("disconnect");
	self endon("killed_player");
	self endon("joined_spectators");

	for(;;)
	{
		if(self useButtonPressed())
		{
			catch_next = false;
			count = 0;

			for(i=0; i<=0.5; i+=0.05)
			{
				if(catch_next && self useButtonPressed() && !(self isMantling()))
				{
					self thread loadPos();
					wait 1;
					break;
				}
				else if(catch_next && self attackButtonPressed() && !(self isMantling()))
				{
					while(self attackButtonPressed() && count < 1)
					{
						count+= 0.1;
						wait 0.1;
					}
					if(count < 1 && self isOnGround() && !(self isMantling()))
						self thread loadPos2();
					else if(count >= 1 && self isOnGround() && !(self isMantling()))
						self thread loadPos3();

					wait 1;
					break;
				}
				else if(!(self useButtonPressed()))
					catch_next = true;

				wait 0.05;
			}
		}
		wait 0.05;
	}
}

loadPos()
{

	if(!isDefined(self.cj["save"]["org1"]))
		self iprintlnbold(self.cj["local"]["NOPOS"]);
	else
	{
		if(!self isOnGround())
		{
			self freezecontrols(true);
			wait 0.1;
			self setPlayerAngles(self.cj["save"]["ang1"]);
			self setOrigin(self.cj["save"]["org1"]);
			wait 0.1;
		}
		else
		{
			self freezecontrols(true);
			wait 0.05;
			self setPlayerAngles(self.cj["save"]["ang1"]);
			self setOrigin(self.cj["save"]["org1"]);
			wait 0.05;
		}

		self iprintln(self.cj["local"]["POSLOAD"]);
		self freezecontrols(false);
	}
}

loadPos2()
{
	if(!isDefined(self.cj["save"]["org2"]))
		self iprintlnbold(self.cj["local"]["NOPOS2"]);
	else
	{
		if(!self isOnGround())
		{
			self freezecontrols(true);
			wait 0.1;
			self setPlayerAngles(self.cj["save"]["ang2"]);
			self setOrigin(self.cj["save"]["org2"]);
			wait 0.1;
		}
		else
		{
			self freezecontrols(true);
			wait 0.05;
			self setPlayerAngles(self.cj["save"]["ang2"]);
			self setOrigin(self.cj["save"]["org2"]);
			wait 0.05;
		}

		self iprintln(self.cj["local"]["POS2LOAD"]);
		self freezecontrols(false);
	}
}

loadPos3()
{
	if(!isDefined(self.cj["save"]["org3"]))
		self iprintlnbold(self.cj["local"]["NOPOS3"]);
	else
	{
		if(!self isOnGround())
		{
			self freezecontrols(true);
			wait 0.1;
			self setPlayerAngles(self.cj["save"]["ang3"]);
			self setOrigin(self.cj["save"]["org3"]);
			wait 0.1;
		}
		else
		{
			self freezecontrols(true);
			wait 0.05;
			self setPlayerAngles(self.cj["save"]["ang3"]);
			self setOrigin(self.cj["save"]["org3"]);
			wait 0.05;
		}

		self iprintln(self.cj["local"]["POS3LOAD"]);
		self freezecontrols(false);
	}
}

savePos()
{
	wait 0.05;
	self.cj["save"]["org1"] = self.origin;
	self.cj["save"]["ang1"] = self getPlayerAngles();
	self iprintln(self.cj["local"]["SAVED"]);
}

savePos2()
{
	wait 0.05;
	self.cj["save"]["org2"] = self.origin;
	self.cj["save"]["ang2"] = self getPlayerAngles();
	self iprintln(self.cj["local"]["SAVED2"]);
}

savePos3()
{
	wait 0.05;
	self.cj["save"]["org3"] = self.origin;
	self.cj["save"]["ang3"] = self getPlayerAngles();
	self iprintln(self.cj["local"]["SAVED3"]);
}

checkSuicide()
{
	self endon("disconnect");
	self endon("joined_spectators");
	self endon("killed_player");

	while(1)
	{
		i = 0;
		while(self meleeButtonPressed() && i < 3)
		{
			wait 0.05;
			i+=0.05;
		}

		if(i > 2)
			self suicide();

		wait 0.1;
	}
}

// Loadout //
checkGrenades()
{
	self endon("disconnect");
	self endon("joined_spectators");
	self endon("killed_player");

	if(getDvar("cj_enablenades") == "1")
	{
		self giveWeapon("frag_grenade_mp");
		self SetWeaponAmmoClip( "frag_grenade_mp", 1 );
		while(1)
		{
			if(self getAmmoCount("frag_grenade_mp") < 1)
				self SetWeaponAmmoClip( "frag_grenade_mp", 1 );

			wait 0.1;
		}
	}
	else
	{
		self setWeaponAmmoClip("frag_grenade_mp", 0);
	}
}

removeAmmo()
{
	self endon("disconnect");
	self endon("joined_spectators");
	self endon("killed_player");

	self takeAllWeapons();

	if(getDvarInt("cj_disablerpg") != 1)
		self giveWeapon("rpg_mp");
	wait 0.05;

	if(isDefined(self.cj["status"]) && self.cj["status"] >= 1)
	{
		self.cj["weapon"] = "deserteaglegold_mp";
		/*self setModel("body_mp_usmc_assault");
		self attach("head_mp_usmc_tactical_mich", "", true);
		self setViewmodel("viewmodel_base_viewhands");
		self.voice = "american";*/
	}
	else
		self.cj["weapon"] = "beretta_mp";

	self giveWeapon("c4_mp");
	self giveWeapon(self.cj["weapon"]);

	wait 0.05;
	self switchToWeapon(self.cj["weapon"]);

	if(isDefined(self.cj["status"]) && self.cj["status"] >= 1)
		self giveMaxAmmo("deserteaglegold_mp");

	self SetActionSlot( 4, "weapon", "rpg_mp" );
	wait 0.05;

	if(getDvarInt("cj_disablerpg") != 1)
	{
		while(1)
		{
			if(self getAmmoCount("rpg_mp") < 1)
				self giveMaxAmmo("rpg_mp");

			if(self getWeaponAmmoClip("rpg_mp") < 1)
				self SetWeaponAmmoClip("rpg_mp", 1);
			wait 3;
		}
	}
}

removePerks()
{
	self endon("disconnect");
	self endon("joined_spectators");
	self endon("killed_player");

	self clearPerks();
	self setPerk("specialty_longersprint");
	self setPerk("specialty_armorvest");
	self setPerk("specialty_fastreload");

	if(self.cj["status"] >= 1)
	{
		self setPerk("specialty_holdbreath");
		self setPerk("specialty_quieter");
	}

	self showPerk( 0, "specialty_longersprint", -50 );
	self showPerk( 1, "specialty_armorvest", -50 );
	self showPerk( 2, "specialty_fastreload", -50 );
	self thread maps\mp\gametypes\_globallogic::hidePerksAfterTime( 3.0 );
	self thread maps\mp\gametypes\_globallogic::hidePerksOnDeath();
}

// Messaging //
doWelcomeMessages()
{
	if(isDefined(self.cj["welcome"]))
		return;

	msg = getDvar("cj_welcome");
	tokens = strTok(msg, "::");

	if(tokens.size == 1)
		self iprintlnbold("" + tokens[0]);
	else if(tokens.size > 1)
	{
		messages = [];

		for(i=0;i<tokens.size;i++)
		{
			if( isEven(i) )
				wait(int(tokens[i]));
			else
				self iprintlnbold("" + tokens[i]);
		}
	}

	self.cj["welcome"] = true;
}

rotateMessage()
{
	level endon ("game_ended");

	if(getDvar("cj_msg_rotate_1") == "")
		return;

	if(getDvar("cj_msg_delay") == "")
		setDvar("cj_msg_delay", 45);

	svrmsg = [];
	i = 1;

	for(;;)
	{
		temp = "cj_msg_rotate_" + i;
		if(getDvar(temp) != "")
			svrmsg[i-1] = getDvar(temp);
		else
			break;

		i++;
		wait 0.05;
	}

	if(svrmsg.size < 1)
		return;

	i = 0;

	delay = getDvarInt("cj_msg_delay");
	for(;;)
	{
		if(i >= svrmsg.size)
			i = 0;

		wait delay;
		iprintln(svrmsg[i]);
		i++;
	}
}
_svr_msg()
{
	level endon("game_ended");
	for(;;)
	{
		size = undefined;
		tokens = [];
		setDvar("cj_svr_msg", "");

		while(1)
		{
			if(getDvar("cj_svr_msg") != "")
				break;
			wait 0.5;
		}

		tokens = strTok(getDvar("cj_svr_msg"), "::");

		if(tokens.size < 1)
			continue;

		if(tokens.size == 1)
		{
			iprintlnbold("" + tokens[0]);
			continue;
		}

		if(tokens.size > 1)
		{
			switch(tokens[0])
			{
				case "bold":
				case "b":
				case "big":
				case "large":
				case "l":
					size = "bold";
					break;
				case "small":
				case "s":
					size = "small";
					break;
				default:
					size = "bold";
			}

			if(size == "small")
				iprintln("" + tokens[1]);
			else
				iprintlnbold("" + tokens[1]);

			continue;
		}

		wait 0.1;
	}
}

_player_msg()
{
	level endon("game_ended");
	for(;;)
	{
		size = undefined;
		name = undefined;
		tokens = [];
		setDvar("cj_player_msg", "");

		while(1)
		{
			if(getDvar("cj_player_msg") != "")
				break;

			wait 0.5;
		}

		tokens = strTok(getDvar("cj_player_msg"), "::");

		// If there are no tokens, then there is an error.
		if(tokens.size < 1)
			continue;

		// If there is only 1 token, then there is an error.
		if(tokens.size == 1)
			continue;

		// If there is only 2 tokens, assume first is player name.
		if(tokens.size == 2)
		{
			players = getentarray("player", "classname");
			name = tokens[0];

			for(i=0;i<players.size;i++)
			{
				tempname = monotone(players[i].name);
				if(isSubStr(tempname, name))
					players[i] iprintlnbold("" + tokens[1]);
			}
		}

		// Correct ammount of tokens.
		if(tokens.size > 2)
		{
			switch(tokens[0])
			{
				case "big":
				case "bold":
				case "b":
				case "large":
					size = "bold";
					break;
				case "small":
				case "s":
					size = "small";
					break;
				default:
					size = "bold";
			}

			players = getentarray("player", "classname");
			name = tokens[1];

			for(i=0;i<players.size;i++)
			{
				tempname = monotone(players[i].name);
				if(isSubStr(tempname, name))
				{
					if(size == "small")
						players[i] iprintln("" + tokens[2]);
					else
						players[i] iprintlnbold("" + tokens[2]);
				}
			}
		}

		wait 0.1;
	}
}

// Admin //
adminSetup()
{
	if((getDvar("cj_adminguids") != "-1") && (getDvarInt("cj_autoadmin") == 1))
		getAdmins();

	thread adminPromote();
	thread adminDemote();
}

getAdmins()
{
	admins = getDvar("cj_adminguids");
	tokens = strTok(admins, ",");
	if(tokens.size <= 1)
	{
		setErr("Admin GUID list not present");
		return;
	}
	else if(!isEven(tokens.size))
	{
		setErr("Admin GUID list not even");
		return;
	}

	level.adminGUIDs = [];
	level.adminNames = [];

	for(i=0;i<tokens.size;i++)
	{
		if(isEven(i))
			level.adminGUIDs[level.adminGUIDs.size] = tokens[i];
		else
			level.adminNames[level.adminNames.size] = tokens[i];
	}
}

checkAdmin()
{
	tempGuid = self getGuid();
	tempName = monotone(self.name);
	num = 0;

	for(i=0;i<level.adminGuids.size;i++)
	{
		if(tempGUID == level.adminGUIDs[i])
		{
			num = i;
			break;
		}
	}

	if((level.adminGUIDs[num] == tempGUID) && (level.adminNames[num] != tempName))
		self thread waitForNameChange(num);
	else if((level.adminGUIDs[num] == tempGUID) && (level.adminNames[num] == tempName))
	{
		self.cj["status"] = 2;
		self thread promotePlayer("2");
	}

}

waitForNameChange(num)
{
	self endon("disconnect");
	self iprintlnbold("^1*** ^2GUID Admin Detected ^1***^7");

	while(self.name != level.adminNames[num])
		wait 2;

	self.cj["status"] = 2;
	self thread promotePlayer("2");
}

adminPromote()
{
	level endon ("game_ended");

	while(1)
	{
		while(getDvar("cj_promote") == "" && getDvar("cj_soviet_promote") == "")
			wait 0.1;



		if(getDvar("cj_soviet_promote") == "")
		{
			promote = "" + getDvarInt("cj_promote");
			pto = 1;
		}
		else
		{
			promote = "" + getDvarInt("cj_soviet_promote");
			pto = 3;
		}

		players = getentarray("player","classname");
		for(i=0;i<players.size;i++)
		{
			temp = "" + players[i] getEntityNumber();
			if(temp == promote && pto == 1)
			{
					players[i] promotePlayer("1");
			}
			else if(temp == promote && pto == 3)
			{
					players[i] promotePlayer("3");
			}
		}
		setDvar("cj_promote", "");
		setDvar("cj_soviet_promote", "");
	}
}

promotePlayer(temprank)
{
	if(self.cj["status"] < 1 && temprank == "1")
	{
		self.cj["status"] = 1;
	}
	else if(self.cj["status"] < 3 && temprank == "3")
	{
		self.cj["status"] = 3;
	}
	else if(self.cj["status"] < 2 && temprank == "2")
	{
		self.cj["status"] = 2;
	}
	self iPrintlnbold(self.cj["local"]["PROMOTED"]);
}

adminDemote()
{
	level endon ("game_ended");

	while(1)
	{
		while(getDvar("cj_demote") == "")
			wait 0.1;

		demote = "" + getDvarInt("cj_demote");

		players = getentarray("player","classname");
		for(i=0;i<players.size;i++)
		{
			temp = "" + players[i] getEntityNumber();
			if(temp == demote)
			{
				players[i] demotePlayer();
				players[i] suicide();
			}
		}
		setDvar("cj_demote", "");
	}
}

demotePlayer()
{
	self.cj["status"] = 0;
	self iPrintlnbold(self.cj["local"]["DEMOTED"]);
}

adminCommand(command, arg)
{
	if(level.players[self.cj["admin"]["playerent"]].cj["status"] < 1 && (command == "kick" || command == "ban"))
	{
		switch(command)
		{
			case "kick":
				self notify("adminclose");
				self iPrintln(level.players[self.cj["admin"]["playerent"]].name+" has been kicked");
				kick(level.players[self.cj["admin"]["playerent"]] getEntityNumber());
				break;
			case "ban":
				self notify("adminclose");
				self iPrintln(level.players[self.cj["admin"]["playerent"]].name+" has been banned");
				ban(level.players[arg] getEntityNumber());
				break;
		}
	}
	else
	{
		switch(command)
			{
				case "promote":
					setDvar("cj_promote", arg);
					break;
				case "demote":
					self notify("adminclose");
					setDvar("cj_demote", arg);
					break;
				case "teletoplayer":
					self setOrigin(level.players[self.cj["admin"]["playerent"]].origin);
					break;
				case "playertele":
					level.players[self.cj["admin"]["playerent"]] setOrigin(self.origin);
					break;
			}
	}
}

textCommand(command, arg)
{
	if(command=="playermessage")
	{
		setDvar("cj_player_msg", self.cj["admin"]["player"]+"::"+arg);
	}
	else if(command=="setspeed")
	{
		level.players[arg] SetMoveSpeedScale(getDvarInt("speed"));
	}
	else if(command=="setname")
	{
		level.players[arg] setClientDvar("name", getDvar("rename"));
	}
}

fullPlayerList()
{
	self endon("adminclose");
	self endon("disconnect");
	self endon("killed_player");
	self.cj["admin"]["player"] = level.players[0].name;
	self.cj["admin"]["playerent"] = level.players[0] getEntityNumber();
	self.cj["admin"]["pm"] = "send a private message";
	self.cj["admin"]["speed"] = "1";
	self.cj["admin"]["rename"] = level.players[0].name;
	self.cj["admin"]["givemenu"] = 0;
	self.cj["admin"]["weapfinal"] = "";
	self.cj["admin"]["attachfinal"] = "";
	self.cj["admin"]["maxent"] = 0;
	self setClientDvar("pm", self.cj["admin"]["pm"]);
	self setClientDvar("speed", self.cj["admin"]["speed"]);
	self setClientDvar("rename", self.cj["admin"]["rename"]);
	self setClientDvar("ui_cj_client", "^7"+level.players[0].name);
	self setClientDvar("ui_cj_client_id", self.cj["admin"]["playerent"]);
	self setClientDvar("ui_cj_client_guid", level.players[0] getGuid());
	self setClientDvar("ui_cj_give_menu", self.cj["admin"]["givemenu"]);
	self setClientDvar("ui_cj_give_weapon", self.cj["admin"]["weapfinal"]);
	self setClientDvar("ui_cj_give_attachment", self.cj["admin"]["attachfinal"]);
	self setClientDvar("ui_cj_give_valid_check", "");
	self setClientDvar("ui_cj_hintstring", "^5>>^7");
	for(;;)
	{
		for(i=0;i<level.players.size;i++)
		{
			if(level.players[i].cj["status"]==1)
			{
				self setClientDvar("ui_cj_player_list_"+level.players[i] getEntityNumber(), "^3"+level.players[i].name);
				self.cj["admin"]["list_id_"+level.players[i] getEntityNumber()] = i;
				if(level.players[i] getEntityNumber()>self.cj["admin"]["maxent"])
					self.cj["admin"]["maxent"]=level.players[i] getEntityNumber()+1;
			}
			else if(level.players[i].cj["status"]>=2)
			{
				self setClientDvar("ui_cj_player_list_"+level.players[i] getEntityNumber(), "^1"+level.players[i].name);
				self.cj["admin"]["list_id_"+level.players[i] getEntityNumber()] = i;
				if(level.players[i] getEntityNumber()>self.cj["admin"]["maxent"])
					self.cj["admin"]["maxent"]=level.players[i] getEntityNumber()+1;
			}
			else if(level.players[i].cj["status"]==0)
			{
				self setClientDvar("ui_cj_player_list_"+level.players[i] getEntityNumber(), "^7"+level.players[i].name);
				self.cj["admin"]["list_id_"+level.players[i] getEntityNumber()] = i;
				if(level.players[i] getEntityNumber()>self.cj["admin"]["maxent"])
					self.cj["admin"]["maxent"]=level.players[i] getEntityNumber()+1;
			}
			else
			{
				self setClientDvar("ui_cj_player_list_"+level.players[i] getEntityNumber(), "");
				self.cj["admin"]["list_id_"+level.players[i] getEntityNumber()] = i;
			}
		}
		self setClientDvar("ui_cj_player_count", self.cj["admin"]["maxent"]);
		if(level.players[self.cj["admin"]["playerent"]].cj["status"]==1)
		{
			self setClientDvar("ui_cj_client", "^3"+level.players[self.cj["admin"]["playerent"]].name);
		}
		else if(level.players[self.cj["admin"]["playerent"]].cj["status"]>=2)
		{
			self setClientDvar("ui_cj_client", "^1"+level.players[self.cj["admin"]["playerent"]].name);
		}
		else
		{
			self setClientDvar("ui_cj_client", "^7"+level.players[self.cj["admin"]["playerent"]].name);
		}
		self.cj["admin"]["pm"] = getDvar("pm");
		self.cj["admin"]["speed"] = getDvar("speed");
		self.cj["admin"]["rename"] = getDvar("rename");
		self setClientDvar("pm", self.cj["admin"]["pm"]);
		self setClientDvar("speed", self.cj["admin"]["speed"]);
		self setClientDvar("rename", self.cj["admin"]["rename"]);
		self.cj["admin"]["player"] = level.players[self.cj["admin"]["playerent"]].name;
		self setClientDvar("ui_cj_client_id", level.players[self.cj["admin"]["playerent"]] getEntityNumber());
		self setClientDvar("ui_cj_client_guid", level.players[self.cj["admin"]["playerent"]] getGuid());
		self setClientDvar("ui_cj_give_menu", self.cj["admin"]["givemenu"]);
		self setClientDvar("ui_cj_give_weapon", self.cj["admin"]["weapfinal"]);
		self setClientDvar("ui_cj_give_attachment", self.cj["admin"]["attachfinal"]);
		if(checkIfWep(self.cj["admin"]["weapfinal"]+self.cj["admin"]["attachfinal"]+"_mp") == true)
			self setClientDvar("ui_cj_give_valid_check", "^2");
		else
			self setClientDvar("ui_cj_give_valid_check", "^1");
		wait 2;
	}
}

checkIfWep(wep)
{
	switch(wep)
	{
		case "ak47_acog_mp":
		case "ak47_gl_mp":
		case "ak47_mp":
		case "ak47_reflex_mp":
		case "ak47_silencer_mp":
		case "ak47u_acog_mp":
		case "ak47u_reflex_mp":
		case "ak47u_silencer_mp":
		case "ak47u_mp":
		case "aw50_acog_mp":
		case "aw50_mp":
		case "barrett_acog_mp":
		case "barrett_mp":
		case "beretta_mp":
		case "beretta_silencer_mp":
		case "brick_blaster_mp":
		case "brick_bomb_mp":
		case "c4_mp":
		case "claymore_mp":
		case "colt45_mp":
		case "colt45_silencer_mp":
		case "concussion_grenade_mp":
		case "defaultweapon_mp":
		case "deserteagle_mp":
		case "deserteaglegold_mp":
		case "dragunov_mp":
		case "dragunov_acog_mp":
		case "flash_grenade_mp":
		case "frag_grenade_mp":
		case "g36c_acog_mp":
		case "g36c_reflex_mp":
		case "g36c_silencer_mp":
		case "g36c_gl_mp":
		case "g36c_mp":
		case "g3_acog_mp":
		case "g3_reflex_mp":
		case "g3_silencer_mp":
		case "g3_gl_mp":
		case "g3_mp":
		case "gl_ak47_mp":
		case "gl_g36c_mp":
		case "gl_g3_mp":
		case "gl_m14_mp":
		case "gl_m4_mp":
		case "gl_mp":
		case "m1014_reflex_mp":
		case "m1014_grip_mp":
		case "m1014_mp":
		case "m14_acog_mp":
		case "m14_reflex_mp":
		case "m14_silencer_mp":
		case "m14_gl_mp":
		case "m14_mp":
		case "m16_acog_mp":
		case "m16_reflex_mp":
		case "m16_silencer_mp":
		case "m16_gl_mp":
		case "m16_mp":
		case "m21_acog_mp":
		case "m21_mp":
		case "m40a3_acog_mp":
		case "m40a3_mp":
		case "m4_acog_mp":
		case "m4_reflex_mp":
		case "m4_silencer_mp":
		case "m4_gl_mp":
		case "m4_mp":
		case "m60e4_acog_mp":
		case "m60e4_reflex_mp":
		case "m60e4_grip_mp":
		case "m60e4_mp":
		case "mp44_mp":
		case "mp5_acog_mp":
		case "mp5_reflex_mp":
		case "mp5_silencer_mp":
		case "mp5_mp":
		case "p90_acog_mp":
		case "p90_reflex_mp":
		case "p90_silencer_mp":
		case "p90_mp":
		case "remington700_acog_mp":
		case "remington700_mp":
		case "rpd_mp":
		case "saw_acog_mp":
		case "saw_reflex_mp":
		case "saw_silencer_mp":
		case "saw_mp":
		case "skorpion_acog_mp":
		case "skorpion_reflex_mp":
		case "skorpion_silencer_mp":
		case "skorpion_mp":
		case "usp_mp":
		case "usp_silencer_mp":
		case "uzi_acog_mp":
		case "uzi_reflex_mp":
		case "uzi_silencer_mp":
		case "uzi_mp":
		case "winchester1200_reflex_mp":
		case "winchester1200_grip_mp":
		case "winchester1200_mp":
			return true;
		default:
			return false;
	}
}

// Voting //
playerList()
{
	self endon("disconnect");
	i = 0;
	self.cj["vote"]["player"] = i;
	self setClientDvar("ui_cj_player", level.players[i].name);
	self.cj["vote"]["playerent"] = level.players[i] getEntityNumber();

	for(;;)
	{
		self waittill("playerlist");
		if(!isDefined(self.cj["vote"]["dir"]))
			self.cj["vote"]["dir"] = "next";

		if(self.cj["vote"]["dir"] == "next")
		{
			i++;
			if(i >= level.players.size)
			i = 0;
			self setClientDvar("ui_cj_player", level.players[i].name);
			self.cj["vote"]["playerent"] = level.players[i] getEntityNumber();
			self.cj["vote"]["player"] = i;
		}
		else if(self.cj["vote"]["dir"] == "prev")
		{
			i--;
			if(i < 0)
			i = level.players.size - 1;
			self setClientDvar("ui_cj_player", level.players[i].name);
			self.cj["vote"]["playerent"] = level.players[i] getEntityNumber();
			self.cj["vote"]["player"] = i;
		}
	}
}

mapBrowse()
{
	self endon("disconnect");
	i = 0;
	self.cj["vote"]["map"] = level.maplist[i];
	self setClientDvar("ui_cj_map", level.maplist[i]);

	for(;;)
	{
		self waittill("maplist");

		if(self.cj["vote"]["dir"] == "mnext")
		{
			i++;
			if(i >= level.maplist.size)
				i = 0;
			self setClientDvar("ui_cj_map", level.maplist[i]);
			self.cj["vote"]["map"] = level.maplist[i];
		}
		else if(self.cj["vote"]["dir"] == "mprev")
		{
			i--;
			if(i < 0)
				i = level.maplist.size - 1;
			self setClientDvar("ui_cj_map", level.maplist[i]);
			self.cj["vote"]["map"] = level.maplist[i];
		}
	}
}

cjVoteCalledPlayer(vote, player, arg)
{
	level endon ("votecancelled");
	level endon ("voteforce");

	if(voteInProgress())
		return;

	if(self.cj["vote"]["novoting"] == true)
	{
		self iprintln("You are currently ^1locked^7 from voting");
		return;
	}

	if(!(self playerCheck(arg)))
	{
		self iprintln("^5* ^7Player cannot be kicked ^5*");
		return;
	}

	level.cjvoteinprogress = 1;

	level.cjvoteagainst = level.players[arg] getEntityNumber();
	level.cjvoteagainstname = level.players[arg].name;
	level.cjvotecalled = player getEntityNumber();
	level.cjvotearg = arg;

	switch(vote)
	{
		case "kick":
			level.cjvotetype = "Vote: Kick Player";
			break;
		default:
			level.cjvotetype = "Vote: Other";
			break;
	}

	iprintln("^5* ^7Vote called by:  ^7" + monotone(self.name) + " ^5*^7");
	player thread disableVoting(level.cjvotelockout);

	for(i=0;i<level.players.size;i++)
	{
		level.players[i] setClientDvar("ui_cj_player_vote",level.cjvoteagainstname);
		level.players[i] setClientDvar("ui_cj_votetype", level.cjvotetype);
		level.players[i] thread startCountdown(level.cjvoteduration);
		level.players[i] thread createVoteHud();
		if(i == arg)
			thread watchPlayer(level.players[i]);
	}

	wait level.cjvoteduration;

	for(i=0;i<level.players.size;i++)
	{
		level.players[i] setClientDvar("ui_cj_player_vote", "");
		level.players[i] setClientDvar("ui_cj_votetype", "");
	}

	//Vote Ended Here
	iprintln("Voted - Yes: ^2" + level.cjvoteyes + "^7 No: ^1" + level.cjvoteno + " ^7Ratio: " + (level.cjvoteyes / (level.cjvoteyes + level.cjvoteno)));

	if((level.cjvoteyes / (level.cjvoteyes + level.cjvoteno)) > level.cjvotewinratio)
	{
		iprintln("^5V^7ote ^2Passed");
		thread compareAndAction(level.cjvotetype, level.cjvoteagainst, level.cjvotearg);
	}
	else
		iprintln("^5V^7ote ^1Failed");



	for(i=0;i<level.players.size;i++)
	{
		level.players[i].cj["vote"]["voted"] = false;
		level.players[i] thread removeVoteHud();
	}

	level.cjvoteinprogress = 0;
	level.cjvoteyes = 0;
	level.cjvoteno = 0;
	level.cjvotetype = "";
	level.cjvotecalled = "";
	level.cjvoteagainst = "";
	level.cjvoteagainstname = "";
	level.cjvotearg = undefined;

	iprintln("^5V^7oting ^3enabled");
}

cjVoteCalledMap(vote, player, arg)
{
	level endon ("votecancelled");
	level endon ("voteforce");

	if(voteInProgress())
		return;

	if(self.cj["vote"]["novoting"] == true)
	{
		self iprintln("You are currently ^1locked^7 from voting");
		return;
	}

	/*if(vote == "change" && getDvar("sv_mapRotationCurrent") == "")
	{
		self iprintln("Current Rotation invalid. Rotate map.");
		return;
	}*/

	level.cjvoteinprogress = 1;
	level.cjvotearg = arg;

	switch(vote)
	{
		case "change":
			level.cjvotetype = "Vote: Change Map";
			break;
		case "extend":
			level.cjvotetype = "Vote: Extend Time";
			break;
		case "rotate":
			level.cjvotetype = "Vote: Rotate Map";
			break;
		default:
			level.cjvotetype = "Vote: Other";
			break;
	}

	iprintln("^5*^7Vote called by:  ^7" + monotone(self.name) + " ^5*^7");
	player thread disableVoting(level.cjvotelockout);

	for(i=0;i<level.players.size;i++)
	{
		level.players[i] setClientDvar("ui_cj_player_vote", level.cjvotearg);
		level.players[i] setClientDvar("ui_cj_votetype", level.cjvotetype);
		level.players[i] thread startCountdown(level.cjvoteduration);
		level.players[i] thread createVoteHud();
	}

	wait level.cjvoteduration;

	for(i=0;i<level.players.size;i++)
	{
		level.players[i] setClientDvar("ui_cj_player_vote", "");
		level.players[i] setClientDvar("ui_cj_votetype", "");
	}

	//Vote Ended Here
	iprintln("Voted - Yes: ^2" + level.cjvoteyes + "^7 No: ^1" + level.cjvoteno + " ^7Ratio: " + (level.cjvoteyes / (level.cjvoteyes + level.cjvoteno)));

	if((level.cjvoteyes / (level.cjvoteyes + level.cjvoteno)) > level.cjvotewinratio)
	{
		iprintln("^5V^7ote ^2Passed");
		thread compareAndAction(level.cjvotetype, undefined, level.cjvotearg);
	}
	else
		iprintln("^5V^7ote ^1Failed");



	for(i=0;i<level.players.size;i++)
	{
		level.players[i] thread removeVoteHud();
		level.players[i].cj["vote"]["voted"] = false;
	}

	level.cjvoteinprogress = 0;
	level.cjvoteyes = 0;
	level.cjvoteno = 0;
	level.cjvotetype = "";
	level.cjvotecalled = "";
	level.cjvotearg = undefined;

	iprintln("^5V^7oting ^3enabled");
}

watchPlayer(player)
{
	while(level.cjvoteinprogress)
	{
		if(!isDefined(player))
			level notify("votecancelled");
		wait 0.5;
	}
}

compareAndAction(vote, against, arg)
{
	switch(vote)
	{
		case "Vote: Kick Player":
			if(against == (level.players[arg] getEntityNumber()))
				kick(level.players[arg] getEntityNumber());
			else
				iprintln("Something went wrong");
			wait 0.05;
			for(i=0;i<level.players.size;i++)
				level.players[i] notify("playerlist");
			break;
		case "Vote: Extend Time":
			temp = getDvarInt("scr_cj_timelimit");
			setDvar("scr_cj_timelimit", (temp + 10));
			break;
		case "Vote: Rotate Map":
			thread maps\mp\gametypes\_globallogic::endGame(undefined, "Vote Passed - Rotating Map");
			break;
		case "Vote: Change Map":
			rotation = " map " + arg + " " + getDvar("sv_mapRotationCurrent");
			setDvar( "sv_mapRotationCurrent", rotation);
			wait 3;
			thread maps\mp\gametypes\_globallogic::endGame(undefined, "Vote Passed - Changing Map");
			break;
		default:
			iprintlnbold("Report Error ["+vote+"]");
	}
}

voteCancelled()
{
	level endon ("game_ended");
	while(1)
	{
		level waittill("votecancelled");
		for(i=0;i<level.players.size;i++)
		{
			level.players[i] setClientDvar("ui_cj_player_vote", "");
			level.players[i] setClientDvar("ui_cj_votetype", "");
		}

		for(i=0;i<level.players.size;i++)
		{
			level.players[i].cj["vote"]["voted"] = false;
			level.players[i] thread removeVoteHud();
		}

		level.cjvoteinprogress = 0;
		level.cjvoteyes = 0;
		level.cjvoteno = 0;
		level.cjvotetype = "";
		level.cjvotecalled = "";
		level.cjvoteagainst = "";
		level.cjvoteagainstname = "";
		level.cjvotearg = undefined;

		iprintln("^5V^7ote ^1Cancelled");
	}
}

voteForced()
{
	level endon ("game_ended");
	while(1)
	{
		level waittill("voteforce");
		for(i=0;i<level.players.size;i++)
		{
			level.players[i] setClientDvar("ui_cj_player_vote", "");
			level.players[i] setClientDvar("ui_cj_votetype", "");
		}

		for(i=0;i<level.players.size;i++)
		{
			level.players[i].cj["vote"]["voted"] = false;
			level.players[i] thread removeVoteHud();
		}

		level.cjvoteinprogress = 0;
		level.cjvoteyes = 0;
		level.cjvoteno = 0;

		thread compareAndAction(level.cjvotetype, level.cjvoteagainst, level.cjvotearg);

		level.cjvotetype = "";
		level.cjvotecalled = "";
		level.cjvoteagainst = "";
		level.cjvoteagainstname = "";
		level.cjvotearg = undefined;
		iprintln("^5V^7ote ^2Forced");
	}
}

timeCount()
{
	self endon("disconnect");
	self endon("killed_player");
	self endon("joined_spectators");
	level endon ("game_ended");

	while(1) // If player has played enough
	{
		self.cj["time"]["played"]++;

		i = floor(self.cj["time"]["played"] / 30); // CHANGE TO 300
		if(i > self.cj["time"]["count"])
		{
				self thread maps\mp\gametypes\_rank::giveRankXP("time", 1 );
				self.cj["time"]["count"]++;
		}

		self setClientDvar("player_summary_time", self.cj["time"]["played"]);

		if(self.cj["time"]["played"] > 120)
			self.cj["vote"]["novoting"] = false;

		wait 1;
	}
}

getPlayerStatus()
{
	level waittill ("game_ended");
	players = getentarray("player", "classname");

	for(i=0;i<players.size;i++)
	{
		if(isDefined(players[i]) && players[i].cj["status"] > 0)
			setDvar("cj_player_" + i, players[i].name + "::" + players[i] getGUID() + "::" + players[i].cj["status"]);
	}
}

checkPlayerStatus()
{
	for(i=0;i<level.cjstatus.size;i++)
	{
		if(level.cjstatus[i].name == self.name)
			if(level.cjstatus[i].guid == self getGUID())
			{
				self.cj["status"] = int(level.cjstatus[i].status);
				break;
			}
	}
}

playerStatusArray()
{
	level.cjstatus = [];
	i = 0;

	for(;;)
	{

		if(isdefined(getDvar("cj_player_" + i)) && getDvar("cj_player_" + i) != "")
		{
			tokens = strTok(getDvar("cj_player_" + i), "::");
			size = level.cjstatus.size;
			level.cjstatus[size] = spawnstruct();
			level.cjstatus[size].name = tokens[0];
			level.cjstatus[size].guid = tokens[1];
			level.cjstatus[size].status = tokens[2];

			setDvar("cj_player_" + i, "");
		}
		else
			break;

		i++;
	}
}

bots()
{
	wait 5;
	iNumBots = 5;
	bots = [];

	for(i = 0; i < iNumBots; i++)
	{
	  bots[i] = addtestclient();
	  bots[i].pers["isBot"] = true;
	  wait 0.05;
	  bots[i] notify("menuresponse", "bot",  "player");
	}
}